(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2013 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)


type stats = private { mutable pass : int;
               tree_size : int;
               mutable fetch_trans_cache_access : int;
               mutable fetch_trans_cache_miss : int;
               mutable eval_trans_cache_access : int;
               mutable eval_trans_cache_miss : int;
               mutable nodes_per_run : int list;
             }

module Make (T : Tree.S) :
sig
  module Tree : Tree.S with type node = T.node
  module ResultSet : Deque.S with type elem = Tree.node

  val eval : Ata.t -> Tree.t -> ResultSet.t -> ResultSet.t
  val full_eval : Ata.t -> Tree.t -> ResultSet.t -> (State.t * ResultSet.t) list
  val stats : unit -> stats
end
